#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

static int f[] = { 57, 57, 57, 57, 77, 102, 128, 153 };

#include "cvt.h"

/* ֐̎dlAȂǂ̓hLgɈړ */
void ym2608adpcm_encode1( short* pcmData, unsigned char* adpcmData, int length, int* guess, int *delta ){
	int i, pcm, adpcm, diff;
	int _guess = *guess;
	int _delta = *delta;
	
	for( i = 0; i < length; i++ ){
		/* PCMf[^̓ǂݍ */
		pcm = pcmData[ i ];
		
		/* \lPCMf[^ւ̍߂ */
		diff = pcm - _guess;
		
		/* ADPCMf[^߂ */
		adpcm = ( lib_abs( diff ) * 4 ) / _delta;
		if( adpcm > 7 ){
			adpcm = 7;
		}
		if( diff < 0 ){
			adpcm = adpcm | 0x8;
		}
		
		/* ADPCMf[^ */
		if( ( i % 2 ) == 0 ){
			adpcmData[ i / 2 ] = ( adpcm << 4 ) & 0xF0;
		}else{
			adpcmData[ i / 2 ] |= ( adpcm << 0 ) & 0x0F;
		}
		
		/* \lXV */
		if( adpcm < 8 ) {
			_guess = _guess + (( adpcm & 7 ) * 2 + 1) * _delta / 8;
		}else{
			_guess = _guess - (( adpcm & 7 ) * 2 + 1) * _delta / 8;
		}
		_guess = ( _guess < -32768 ) ? -32768 : _guess;
		_guess = ( _guess > 32767 ) ? 32767 : _guess;

		/* ̊lXV */
		_delta = _delta * f[ adpcm & 7 ] / 64;
		
		_delta = ( _delta < 127 ) ? 127 : _delta;
		_delta = ( _delta > 24576 ) ? 24576 : _delta;
		
	}
	*guess = _guess;
	*delta = _delta;
}


/* ֐̎dlAȂǂ̓hLgɈړ */
void ym2608adpcm_encode2( short* pcmData, unsigned char* adpcmData, int length, int* guess, int* delta ){
	int i;
	int pcm[ 2 ];
	int adpcm[ 2 ];
	int diff[ 2 ];
	int _guess[ 2 ];
	int _delta[ 2 ];

	_guess[ 0 ] = guess[ 0 ];
	_guess[ 1 ] = guess[ 1 ];
	_delta[ 0 ] = delta[ 0 ];
	_delta[ 1 ] = delta[ 1 ];
	
	for( i = 0; i < length; ++i ){
		/* PCMf[^̓ǂݍ */
		pcm[ 0 ] = pcmData[ i * 2 + 0 ];
		pcm[ 1 ] = pcmData[ i * 2 + 1 ];
		
		/* \lPCMf[^ւ̍߂ */
		diff[ 0 ] = pcm[ 0 ] - _guess[ 0 ];
		diff[ 1 ] = pcm[ 1 ] - _guess[ 1 ];
		
		/* ADPCMf[^߂ */
		adpcm[ 0 ] = ( lib_abs( diff[ 0 ] ) * 4 ) / _delta[ 0 ];
		if( adpcm[ 0 ] > 7 ){
			adpcm[ 0 ] = 7;
		}
		if( diff[ 0 ] < 0 ){
			adpcm[ 0 ] = adpcm[ 0 ] | 0x8;
		}
		adpcm[ 1 ] = ( lib_abs( diff[ 1 ] ) * 4 ) / _delta[ 1 ];
		if( adpcm[ 1 ] > 7 ){
			adpcm[ 1 ] = 7;
		}
		if( diff[ 1 ] < 0 ){
			adpcm[ 1 ] = adpcm[ 1 ] | 0x8;
		}
		
		/* ADPCMf[^ */
		adpcmData[ i ] = ( ( adpcm[ 0 ] << 4 ) & 0xF0 ) | ( ( adpcm[ 1 ] << 0 ) & 0x0F );
		
		/* \lXV */
		if( adpcm[ 0 ] < 8 ) {
			_guess[ 0 ] = _guess[ 0 ] + (( adpcm[ 0 ] & 7 ) * 2 + 1 ) * _delta[ 0 ] / 8;
		}else{
			_guess[ 0 ] = _guess[ 0 ] - (( adpcm[ 0 ] & 7 ) * 2 + 1 ) * _delta[ 0 ] / 8;
		}
		_guess[ 0 ] = ( _guess[ 0 ] < -32768 ) ? -32768 : _guess[ 0 ];
		_guess[ 0 ] = ( _guess[ 0 ] > 32767 ) ? 32767 : _guess[ 0 ];
		if( adpcm[ 1 ] < 8 ) {
			_guess[ 1 ] = _guess[ 1 ] + (( adpcm[ 1 ] & 7 ) * 2 + 1 ) * _delta[ 1 ] / 8;
		}else{
			_guess[ 1 ] = _guess[ 1 ] - (( adpcm[ 1 ] & 7 ) * 2 + 1 ) * _delta[ 1 ] / 8;
		}
		_guess[ 1 ] = ( _guess[ 1 ] < -32768 ) ? -32768 : _guess[ 1 ];
		_guess[ 1 ] = ( _guess[ 1 ] > 32767 ) ? 32767 : _guess[ 1 ];

		/* ̊lXV */
		_delta[ 0 ] = _delta[ 0 ] * f[ adpcm[ 0 ] & 7 ] / 64;
		
		_delta[ 0 ] = ( _delta[ 0 ] < 127 ) ? 127 : _delta[ 0 ];
		_delta[ 0 ] = ( _delta[ 0 ] > 24576 ) ? 24576 : _delta[ 0 ];

		_delta[ 1 ] = _delta[ 1 ] * f[ adpcm[ 1 ] & 7 ] / 64;
		
		_delta[ 1 ] = ( _delta[ 1 ] < 127 ) ? 127 : _delta[ 1 ];
		_delta[ 1 ] = ( _delta[ 1 ] > 24576 ) ? 24576 : _delta[ 1 ];
		
	}
	guess[ 0 ] = _guess[ 0 ];
	guess[ 1 ] = _guess[ 1 ];
	delta[ 0 ] = _delta[ 0 ];
	delta[ 1 ] = _delta[ 1 ];
}
	
#ifdef __cplusplus
}
#endif /* __cplusplus */
