#ifndef __fileload__
#define __fileload__

const int MAX_FILE_NUMBER = 0x100;

struct SDL_Surface;

namespace Utility {

	enum {
		TYPE_NORMAL,
		TYPE_SDL_SURFACE,
		TYPE_NUM
	};

	struct FileUnit {
		char tag[ 0x100 ];
		char* ptr;
		int length;
		int type;
	};


	class FileLoad {
	public:
		FileLoad();
		virtual ~FileLoad();

		bool load( const char* filename, const char* tag, int type = 0 );
		void release( void );    
		char* getPtr( char* tag );
		int getLength( char* tag );
		SDL_Surface* getSurface( char* tag );

	protected:
		struct FileUnit _data[ MAX_FILE_NUMBER ];
		bool _valid;
		
	};
}
#endif /* __fileload__ */

