#ifndef __sound_core__
#define __sound_core__

struct SoundInterface {
	virtual ~SoundInterface(){}
	virtual void fill( int* stream, int length )=0;
};


extern "C" {

	const int SOUND_GAME_VOLUME = 128;
	const int SOUND_USER_VOLUME = 16;

	struct SoundFillCount {
		int count;
		int second;
	};

	bool SDL_SoundOpenDevice( int, int, int );
	void SDL_SoundCloseDevice( void );

	void SDL_SoundFill( void* udata, unsigned char* stream, int length );
	int SDL_SoundSetCallback( int, SoundInterface* );
	void SDL_SoundClearCallback( void );

	void SDL_SoundEnableSoundDevice();
	void SDL_SoundDisableSoundDevice();

}


#endif // __sound_core__
