#include "timer.h"

#include <SDL.h>

using namespace Device;

TimerSDL::TimerSDL():_fps( 60 ){
}

void TimerSDL::setFPS( int data ){
	if( data < 1 ){
		return; // sȓ
	}
	_fps = data;
	_add = ( 1000 << 16 ) / _fps;
	reset();
}

void TimerSDL::reset( void ){
	resetTick();
	addTick();
}

void TimerSDL::wait( void ){
	int time = _tickh - SDL_GetTicks();
	if( time < 1 ){
		// xĂ
		if( _skipCount > 4 ){
			resetTick();
		}else{
			_skipFlag = true;
			++_skipCount;
		}
	}else{
		_skipFlag = false;
		_skipCount = 0;
		while( SDL_GetTicks() < _tickh ){
			SDL_Delay( 1 );
		}
	}
	addTick();
}

bool TimerSDL::isFrameSkip( void ){
	return _skipFlag;
}

void TimerSDL::addTick( void ){
	_tickl += _add;
	_tickh += ( _tickl >> 16 );
	_tickl &= 0xFFFF;
}

void TimerSDL::resetTick( void ){
	_tickh = SDL_GetTicks();
	_tickl = 0;
	_skipFlag = false;
	_skipCount = 0;
}
